
#include <pw/core/frustum.hpp>

#include <print>
#include <vector>

auto main() -> int {

    auto frustum_p = pw::frustum<float>::make_perspective_symmetric(
        45.f, float{320} / 240, 0.1f, 1'000.f);

    auto frustum_o = pw::frustum<float>::make_orthographic_symmetric(
        1.5f, float{320} / 240, 0.1f, 1'000.f);

    std::print("l:{} r:{} b:{} t:{} n:{} f:{}\n", frustum_p.left,
               frustum_p.right, frustum_p.bottom, frustum_p.top, frustum_p.z_near,
               frustum_p.z_far);

    std::print("l:{} r:{} b:{} t:{} n:{} f:{}\n", frustum_p.left,
               frustum_o.right, frustum_o.bottom, frustum_o.top, frustum_o.z_near,
               frustum_o.z_far);
}
