#ifndef PW_SYSTEM_INPUT_HPP
#define PW_SYSTEM_INPUT_HPP

#include <cstdint>
#include <pw/core/globals.hpp>
#include <pw/core/point.hpp>

namespace pw {

struct input final {

    static input& get();

    point<int32_t> mouse_position() const { return _mouse_position; }

    bool mouse_pressed() const { return _mouse_pressed; }
    int mouse_button() const { return _mouse_button; }

    bool has_input() const { return !_input_string.empty(); }
    std::string input_string() const { return _input_string; }

    ~input() = default;

    enum mouse_button_state { pressed, released };

    void reset();

  protected:
    friend class window;

    input() = default;

  private:
    point<int32_t> _mouse_position;
    int _mouse_button;
    bool _mouse_pressed;

    int _key_code;
    bool _key_pressed;

    std::string _input_string;
};

} // namespace pw

#endif
