#ifndef PW_VISUAL_FRAMEBUFFER_HPP
#define PW_VISUAL_FRAMEBUFFER_HPP

#include <pw/core/globals.hpp>
#include <pw/core/size.hpp>

namespace pw {

struct framebuffer final {
    framebuffer();
    ~framebuffer();

    bool create(const size<int32_t>& s);

    void bind();
    void blit();
    void unbind();

  protected:
    struct impl;
    std::unique_ptr<impl> _impl;
};

} // namespace pw
#endif
