#ifndef PW_VISUAL_MESH_RENDERER_HPP
#define PW_VISUAL_MESH_RENDERER_HPP

#include <map>
#include <memory>

namespace pw {

struct mesh;

/**
 * @brief builds a renderer for meshes
 */
struct renderer final {
    renderer();
    renderer(const mesh& m);

    ~renderer();

    bool update(const mesh& m);
    void release();

    void draw();
    bool ready() const;

  protected:
    struct impl;
    std::unique_ptr<impl> _impl;
};

} // namespace pw

#endif
